package com.pj.project.tb_car;

import java.util.List;

import com.pj.utils.so.SoMap;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.*;

import com.pj.utils.sg.*;
import com.pj.project4sp.SP;

import com.pj.current.satoken.StpUserUtil;
import cn.dev33.satoken.annotation.SaCheckPermission;
import org.springframework.web.multipart.MultipartFile;


/**
 * Controller: tb_car -- 
 * @author qzy 
 */
@RestController
@RequestMapping("/TbCar/")
public class TbCarController {

	/** 底层 Service 对象 */
	@Autowired
	TbCarService tbCarService;

	/** 增 */  
	@RequestMapping("add")
	@SaCheckPermission(TbCar.ADD)
	@Transactional(rollbackFor = Exception.class)
	public AjaxJson add(TbCar t){
		tbCarService.add(t);
		return AjaxJson.getSuccess();
	}

	/** 删 */  
	@RequestMapping("delete")
	@SaCheckPermission(TbCar.DEL)
	public AjaxJson delete(Long id){
		 tbCarService.delete(id);
		return AjaxJson.getSuccess();
	}
	
	/** 删 - 根据id列表 */  
	@RequestMapping("deleteByIds")
	@SaCheckPermission(TbCar.DEL)
	public AjaxJson deleteByIds(){
		List<Long> ids = SoMap.getRequestSoMap().getListByComma("ids", long.class);
		int line = SP.publicMapper.deleteByIds(TbCar.TABLE_NAME, ids);
		return AjaxJson.getByLine(line);
	}
	
	/** 改 */  
	@RequestMapping("update")
	@SaCheckPermission(TbCar.EDIT)
	public AjaxJson update(TbCar t){
		tbCarService.update(t);
		return AjaxJson.getSuccess();
	}

	/** 查 - 根据id */  
	@RequestMapping("getById")
	public AjaxJson getById(Long id){
		TbCar t = tbCarService.getById(id);
		return AjaxJson.getSuccessData(t);
	}

	/** 查集合 - 根据条件（参数为空时代表忽略指定条件） */  
	@RequestMapping("getList")
	public AjaxJson getList() { 
		SoMap so = SoMap.getRequestSoMap();
		List<TbCar> list = tbCarService.getList(so.startPage());
		return AjaxJson.getPageData(so.getDataCount(), list);
	}

	/** 查集合 - 根据条件（参数为空时代表忽略指定条件） */
	@RequestMapping("importExcel")
	@SaCheckPermission(TbCar.IMPORT)
	public AjaxJson importExcel(MultipartFile file)throws Exception {
		tbCarService.importExcel(file);
		return AjaxJson.getSuccess();
	}

	
	
	
	// ------------------------- 前端接口 -------------------------
	
	
	/** 改 - 不传不改 [G] */
	@RequestMapping("updateByNotNull")
	public AjaxJson updateByNotNull(Long id){
		AjaxError.throwBy(true, "如需正常调用此接口，请删除此行代码");
		// 鉴别身份，是否为数据创建者 
		long userId = SP.publicMapper.getColumnByIdToLong(TbCar.TABLE_NAME, "user_id", id);
		AjaxError.throwBy(userId != StpUserUtil.getLoginIdAsLong(), "此数据您无权限修改");
		// 开始修改 (请只保留需要修改的字段)
		SoMap so = SoMap.getRequestSoMap();
		so.clearNotIn("id", "cardNo", "cardSize", "lastGoodsName", "lastGoodsCode", "lastNetWeight", "lastInTime", "lastOutTime", "status").clearNull().humpToLineCase();	
		int line = SP.publicMapper.updateBySoMapById(TbCar.TABLE_NAME, so, id);
		return AjaxJson.getByLine(line);
	}
	
	
	
	
	
	

}
